/* 
///////////////////////////////////////////////////////
This Platformer example was coded by Voxel Studios   //
for the Nintendo 3DS (homebrew), and is free and     //
open source for anyone to edit. Graphics used in     //
this example are property of Voxel Studios.          //
                                                     //
Shout-out to the following people:                   //
- Voxel Studios (me) - Graphics and code cleanup.    //
- Garcia98 - Helping me get started with homebrew.   //
- Smea - Author of Ninjhax/Ironhax/Tubehax.          //
  Without this awesome fella, I wouldn't be a        //
  block comment telling you how awesome this guy is! //
                                                     //
- Also some others I'm sure to miss...               //
///////////////////////////////////////////////////////
*/

// Include needed header
#include <stdio.h>
#include <stdlib.h>
#include <3ds.h>
#include <sf2d.h>
#include <sfil.h>

//Slider Stuff
#define CONFIG_3D_SLIDERSTATE (*(float*)0x1FF81080)

int interaxial = 20;
int xpos = 100;
int viewpos = 100;
int ypos = 60;
float yvelocity = 0.0f;

int CanJump = 1; // 1 = Jumping Enabled; 2 = Jumping Disabled

int facing = 0; // 0 = facing right; 1 = facing left

// Respective platform positions on the X axis
float scenepos = 0.0f;
int plat1pos = 0;
int plat2pos = 256;
int plat3pos = 512;
int plat4pos = 768;

// Include images
#include "run_left1_png.h"
#include "run_left2_png.h"
#include "run_left3_png.h"

#include "run_right1_png.h"
#include "run_right2_png.h"
#include "run_right3_png.h"

#include "stop_left_png.h"
#include "stop_right_png.h"

#include "jump1_png.h"
#include "jump2_png.h"
#include "jump3_png.h"
#include "jump4_png.h"

#include "floor_png.h"
#include "scene_png.h"

int main()
{
	// Initialize services
	sf2d_init();
	
	// Enable 3D
	sf2d_set_3D(1);

	// Load images
	sf2d_texture *Scene = sfil_load_PNG_buffer(scene_png, SF2D_PLACE_RAM);
	sf2d_texture *Floor = sfil_load_PNG_buffer(floor_png, SF2D_PLACE_RAM);
	
	sf2d_texture *RunRight1 = sfil_load_PNG_buffer(run_right1_png, SF2D_PLACE_RAM);
	sf2d_texture *RunRight2 = sfil_load_PNG_buffer(run_right2_png, SF2D_PLACE_RAM);
	sf2d_texture *RunRight3 = sfil_load_PNG_buffer(run_right3_png, SF2D_PLACE_RAM);

	sf2d_texture *RunLeft1 = sfil_load_PNG_buffer(run_left1_png, SF2D_PLACE_RAM);
	sf2d_texture *RunLeft2 = sfil_load_PNG_buffer(run_left2_png, SF2D_PLACE_RAM);
	sf2d_texture *RunLeft3 = sfil_load_PNG_buffer(run_left3_png, SF2D_PLACE_RAM);

	sf2d_texture *StopRight = sfil_load_PNG_buffer(stop_right_png, SF2D_PLACE_RAM);
	sf2d_texture *StopLeft = sfil_load_PNG_buffer(stop_left_png, SF2D_PLACE_RAM);
	
	sf2d_texture *Jump1 = sfil_load_PNG_buffer(jump1_png, SF2D_PLACE_RAM);
	sf2d_texture *Jump2 = sfil_load_PNG_buffer(jump2_png, SF2D_PLACE_RAM);
	sf2d_texture *Jump3 = sfil_load_PNG_buffer(jump3_png, SF2D_PLACE_RAM);
	sf2d_texture *Jump4 = sfil_load_PNG_buffer(jump4_png, SF2D_PLACE_RAM);

	int image = 0;
	int timeright = 0;
	int timeleft = 0;
	int timejump = 0;

	// Main loop
	while (aptMainLoop())
	{
		// Scan all the inputs. This should be done once for each frame
		hidScanInput();

		// hidKeysDown returns information about which buttons have been just pressed
		u32 kDown = hidKeysDown();
		u32 kHeld = hidKeysHeld();
		u32 kUp = hidKeysUp();

		if (kDown & KEY_START){
			break;	// Break in order to return to hbmenu
		} else if (kDown & KEY_RIGHT){ //Set image value to run_right.
			facing = 0;
			if (CanJump == 1){
			if (timeright != 1){
				timeright = 1;
			}
			}
		} else if (kHeld & KEY_RIGHT){ // Running Right
			if (CanJump == 1){
			if (image == 0){
				image = 1;
			}
			}
			//Animation Timer//////////
			///////////////////////////
			if ((timeright>=1) & (timeright<=29)){
				timeright++;
			} else if (timeright==30){
				timeright = 1;
			}
			///////////////////////////
			if (CanJump == 1){
			if (timeright == 2){ //1st animation
				image = 1;
			} else if (timeright == 11){ // 2nd animation
				image = 2;
			} else if (timeright == 21){ // 3rd animation
				image = 3;
			}
			////////////////////
			}
			if (viewpos <= 150){
				xpos = xpos + 3; // Running speed
				plat1pos = 0;
				plat2pos = 256;
				plat3pos = 512;
				plat4pos = 768;
				scenepos = 0;
			} else if (viewpos > 150){
				plat1pos = plat1pos - 3;
				plat2pos = plat2pos - 3;
				plat3pos = plat3pos - 3;
				plat4pos = plat4pos - 3;
				scenepos = scenepos - 1.0f;
			}
			if (viewpos >= 448){
				xpos = xpos + 3; // Running speed
				plat1pos = 144;
				plat2pos = -112;
				plat3pos = -368;
				plat4pos = 400;
				scenepos = -100;
			}
			viewpos = viewpos + 3;
		} else if (kUp & KEY_RIGHT){
			timeright = 0; // Set timer to temporary 0
			if (CanJump == 1){
			image = 0; // Set animation to stood right
			}
		}
		
		if (kDown & KEY_LEFT){ //Set image value to run_left.
			facing = 1;
			if (CanJump == 1){
			if (timeleft != 1){
				timeleft = 1;
			}
			}
		} else if (kHeld & KEY_LEFT){ // Running Left
			if (CanJump == 1){
			if (image == 4){
				image = 5;
			}
			}
			//Animation Timer//////////
			///////////////////////////
			if ((timeleft>=1) & (timeleft<=29)){
				timeleft++;
			} else if (timeleft==30){
				timeleft = 1;
			}
			///////////////////////////
			if (CanJump == 1){
			if (timeleft == 2){ //1st animation
				image = 5;
			} else if (timeleft == 11){ // 2nd animation
				image = 6;
			} else if (timeleft == 21){ // 3rd animation
				image = 7;
			}
			////////////////////
			}
			if (viewpos <= 150){
				xpos = xpos - 3; // Running speed
				plat1pos = 0;
				plat2pos = 256;
				plat3pos = 512;
				plat4pos = 768;
				scenepos = 0;
			} else if (viewpos > 150){
				plat1pos = plat1pos + 3;
				plat2pos = plat2pos + 3;
				plat3pos = plat3pos + 3;
				plat4pos = plat4pos + 3;
				scenepos = scenepos + 1.0f;
			}
			if (viewpos >= 448){
				xpos = xpos - 3; // Running speed
				plat1pos = 144;
				plat2pos = -112;
				plat3pos = -368;
				plat4pos = 400;
				scenepos = -100;
			}
			viewpos = viewpos - 3;
		} else if (kUp & KEY_LEFT){
			timeleft = 0; // Set timer to temporary 0
			if (CanJump == 1){
			image = 4; // Set animation to stood left
			}
		}
		
		// Initialize gravity system
		ypos = ypos + yvelocity;
		
		if (ypos < 60){
			yvelocity = yvelocity + 0.3f;
			
			//Jump Animation Timer/////
			///////////////////////////
			if ((timejump>=1) & (timejump<=19)){
				timejump++;
			} else if (timejump==20){
				timejump = 1;
			}
			///////////////////////////
			if (timejump == 2){ //1st animation
				image = 8;
			} else if (timejump == 6){ // 2nd animation
				image = 9;
			} else if (timejump == 11){ // 3rd animation
				image = 10;
			} else if (timejump == 16){ // 4th animation
				image = 11;
			}
			////////////////////
		} else if (ypos >= 60){
			yvelocity = 0.0f;
			CanJump = 1;
			timejump = 0;
			if (image == 8 || image == 9 || image == 10 || image == 11){
				if (facing == 0){
					if(timeright == 0){
					image = 0;
					}
					if(timeright != 0){
						image = 1;
					}
				}
				if (facing == 1){
					if(timeleft == 0){
					image = 4;
					}
					if(timeleft != 0){
						image = 5;
					}
				}
			}
		}
		
		// Jump code...
		if (kDown & KEY_A){
			if (CanJump == 1){
				if (timejump != 1){
					timejump = 1;
				}
				yvelocity = -7.5f;
				CanJump = 0;
			}
		}
		
		int left_eye = (CONFIG_3D_SLIDERSTATE*-1) * (interaxial*-1);

		// Draw image in 3D
		sf2d_start_frame(GFX_TOP, GFX_LEFT);
			sf2d_draw_texture(Scene, scenepos, 0);
			sf2d_draw_texture(Floor, plat1pos, 185);
			sf2d_draw_texture(Floor, plat2pos, 185);
			sf2d_draw_texture(Floor, plat3pos, 185);
			sf2d_draw_texture(Floor, plat4pos, 185);
			
			if (image == 0){
				sf2d_draw_texture(StopRight, xpos, ypos);
			} else if (image == 1){
				sf2d_draw_texture(RunRight1, xpos, ypos);
			} else if (image == 2){
				sf2d_draw_texture(RunRight2, xpos, ypos);
			} else if (image == 3){
				sf2d_draw_texture(RunRight3, xpos, ypos);
			} else if (image == 4){
				sf2d_draw_texture(StopLeft, xpos, ypos);
			} else if (image == 5){
				sf2d_draw_texture(RunLeft1, xpos, ypos);
			} else if (image == 6){
				sf2d_draw_texture(RunLeft2, xpos, ypos);
			} else if (image == 7){
				sf2d_draw_texture(RunLeft3, xpos, ypos);
			} else if (image == 8){
				sf2d_draw_texture(Jump1, xpos, ypos);
			} else if (image == 9){
				sf2d_draw_texture(Jump2, xpos, ypos);
			} else if (image == 10){
				sf2d_draw_texture(Jump3, xpos, ypos);
			} else if (image == 11){
				sf2d_draw_texture(Jump4, xpos, ypos);
			}
		sf2d_end_frame();
		sf2d_start_frame(GFX_TOP, GFX_RIGHT);
			sf2d_draw_texture(Scene, scenepos - (left_eye/3), 0);
			sf2d_draw_texture(Floor, plat1pos - left_eye, 185);
			sf2d_draw_texture(Floor, plat2pos - left_eye, 185);
			sf2d_draw_texture(Floor, plat3pos - left_eye, 185);
			sf2d_draw_texture(Floor, plat4pos - left_eye, 185);
			
			if (image == 0){
				sf2d_draw_texture(StopRight, xpos - left_eye, ypos);
			} else if (image == 1){
				sf2d_draw_texture(RunRight1, xpos - left_eye, ypos);
			} else if (image == 2){
				sf2d_draw_texture(RunRight2, xpos - left_eye, ypos);
			} else if (image == 3){
				sf2d_draw_texture(RunRight3, xpos - left_eye, ypos);
			} else if (image == 4){
				sf2d_draw_texture(StopLeft, xpos - left_eye, ypos);
			} else if (image == 5){
				sf2d_draw_texture(RunLeft1, xpos - left_eye, ypos);
			} else if (image == 6){
				sf2d_draw_texture(RunLeft2, xpos - left_eye, ypos);
			} else if (image == 7){
				sf2d_draw_texture(RunLeft3, xpos - left_eye, ypos);
			} else if (image == 8){
				sf2d_draw_texture(Jump1, xpos - left_eye, ypos);
			} else if (image == 9){
				sf2d_draw_texture(Jump2, xpos - left_eye, ypos);
			} else if (image == 10){
				sf2d_draw_texture(Jump3, xpos - left_eye, ypos);
			} else if (image == 11){
				sf2d_draw_texture(Jump4, xpos - left_eye, ypos);
			}
			
			
		sf2d_end_frame();

		// Swap frame buffers
		sf2d_swapbuffers();
	}

	// Free the textures
	sf2d_free_texture(Scene);
	sf2d_free_texture(Floor);
	sf2d_free_texture(StopRight);
	sf2d_free_texture(StopLeft);
	sf2d_free_texture(RunRight1);
	sf2d_free_texture(RunRight2);
	sf2d_free_texture(RunRight3);
	sf2d_free_texture(RunLeft1);
	sf2d_free_texture(RunLeft2);
	sf2d_free_texture(RunLeft3);
	sf2d_free_texture(Jump1);
	sf2d_free_texture(Jump2);
	sf2d_free_texture(Jump3);
	sf2d_free_texture(Jump4);

	// End services
	sf2d_fini();

	return 0;
}
